---------------------------------------------------------------------------
-- Voxelis - Voxel survival sandbox for Luanti
-- Copyright (C) 2024 Mad Star Studio LLC
-- 
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 3 of the License, or
-- (at your option) any later version.
--
-- You should have received a copy of the GNU General Public License along
-- with this program; if not, see <http://www.gnu.org/licenses/>.
---------------------------------------------------------------------------

vox_core = {}

-- Load from minerals.lua
dofile(core.get_modpath("vox_core").."/minerals.lua")
-- Load from ores.lua
dofile(core.get_modpath("vox_core").."/ores.lua")
-- Load from gems.lua
dofile(core.get_modpath("vox_core").."/gems.lua")
-- Load from liquids.lua
dofile(core.get_modpath("vox_core").."/liquids.lua")
-- Load from trees.lua
dofile(core.get_modpath("vox_core").."/trees.lua")
-- Load from plants.lua
dofile(core.get_modpath("vox_core").."/plants.lua")

-- Load from ocean.lua
dofile(core.get_modpath("vox_core").."/ocean.lua")
-- Load from sky_island.lua
dofile(core.get_modpath("vox_core").."/sky_island.lua")

-- Load from mobdrops.lua
dofile(minetest.get_modpath("vox_core").."/mobdrops.lua")
-- Load from mats.lua
dofile(minetest.get_modpath("vox_core").."/mats.lua")



-- Load from functions.lua
-- This is copy/paste from 'default' mod and we're using it temporarily(?)
--dofile(minetest.get_modpath("vox_core").."/functions.lua")

-- Glowing Moss
core.register_node("vox_core:glowing_moss", {
    description = "Glowing Moss",
    tiles = {"vox_glowing_moss.png"},
    light_source = 8,
    groups = {crumbly = 1}
})
core.register_alias("glowing_moss", "vox_core:glowing_moss")


-- ---------------------------- Dyeable Nodes -------------------------- --
-- List of dyeable things
local dyeable_blocks = {"sand", "terracotta", "marble", "cobblestone", "sandstone"}